#ifndef __LIBM_SNPRINTF__
#define __LIBM_SNPRINTF__

#include <stdarg.h>
#ifndef _WIN32
#include <sys/ioctl.h>
#include <sys/param.h>
#endif
#include "monetra.h"


/* SNPRINTF REPLACEMENT CALLS */
int M_snprintf(char *str, size_t count, const char *fmt,...);
int M_vsnprintf(char *str, size_t count, const char *fmt, va_list args);
#define M_vasprintf2(a,b,c,d) M_vasprintf_real(a,b,c,d,__FILE__,__LINE__)
int M_vasprintf_real(char **ret, const char *fmt, va_list args, va_list args2, const char *file, long line);
#ifdef _WIN32
int M_asprintf(char **ret, const char *fmt, ...);
#else
int M_asprintf_real (const char *file, long line, char **ret, const char *fmt, ...);
#define M_asprintf(a,...) M_asprintf_real(__FILE__,__LINE__,a,__VA_ARGS__)

#endif
int M_vfprintf(FILE *fp, const char *fmt, va_list args);
int M_fprintf(FILE *fp, const char *fmt, ...);
int M_vprintf(const char *fmt, va_list args);
int M_printf(const char *fmt, ...);

#endif

